(*
 *  Typechecking
 *)

(* Write ctx1 < ctx2 to mean that 
 1) If Bind(x,a):ctx1 then Bind(x,a'):ctx2 and leq_asp a' a 
 2) The abbreviations in ctx1 are the same as those in ctx2

The call (check ctx e) either fails or returns a context ctx1, a term e' and a
type t such that

 1) ctx1 < ctx
 2) ctx1 |- e : t
 3) If ctx2 < ctx and ctx2 |- e : t' then ctx1<ctx2 and t<t' 
 4) The term e' is the same as e except for inferred aspect annotations in 
    abstractions and let expressions. *)

val check : Typcontext.ctx -> Exp.t -> Typcontext.ctx * Exp.t * Typ.t



